3 . git-sh-setup || die "Not a git archive"
5 _x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
6 _x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
17 while case "$#" in 0) break ;; esac
20 -a|--a|--ap|--app|--appe|--appen|--append)
23 -f|--f|--fo|--for|--forc|--force)
26 -t|--t|--ta|--tag|--tags)
29 -u|--u|--up|--upd|--upda|--updat|--update|--update-|--update-h|\
30 --update-he|--update-hea|--update-head|--update-head-|\
31 --update-head-o|--update-head-ok)
46 test -f "$GIT_DIR/branches/origin" ||
47 test -f "$GIT_DIR/remotes/origin" ||
48 die "Where do you want to fetch from today?"
53 remote=$(get_remote_url "$@")
56 rsync_slurped_objects=
58 if test "" = "$append"
60 : >"$GIT_DIR/FETCH_HEAD"
63 append_fetch_head () {
70 t) not_for_merge_='not-for-merge' ;;
71 '') not_for_merge_= ;;
74 # remote-nick is the URL given on the command line (or a shorthand)
75 # remote-name is the $GIT_DIR relative refs/ path we computed
77 case "$remote_name_" in
81 note_="$(expr "$remote_name_" : 'refs/heads/\(.*\)')"
82 note_="branch '$note_' of " ;;
84 note_="$(expr "$remote_name_" : 'refs/tags/\(.*\)')"
85 note_="tag '$note_' of " ;;
87 note_="$remote_name of " ;;
89 remote_1_=$(expr "$remote_" : '\(.*\)\.git/*$') &&
91 note_="$note_$remote_"
93 # 2.6.11-tree tag would not be happy to be fed to resolve.
94 if git-cat-file commit "$head_" >/dev/null 2>&1
96 headc_=$(git-rev-parse --verify "$head_^0") || exit
97 echo "$headc_ $not_for_merge_ $note_" >>"$GIT_DIR/FETCH_HEAD"
98 [ "$verbose" ] && echo >&2 "* committish: $head_"
99 [ "$verbose" ] && echo >&2 " $note_"
101 echo "$head_ not-for-merge $note_" >>"$GIT_DIR/FETCH_HEAD"
102 [ "$verbose" ] && echo >&2 "* non-commit: $head_"
103 [ "$verbose" ] && echo >&2 " $note_"
105 if test "$local_name_" != ""
107 # We are storing the head locally. Make sure that it is
108 # a fast forward (aka "reverse push").
109 fast_forward_local "$local_name_" "$head_" "$note_"
113 fast_forward_local () {
114 mkdir -p "$(dirname "$GIT_DIR/$1")"
117 # Tags need not be pointing at commits so there
118 # is no way to guarantee "fast-forward" anyway.
119 if test -f "$GIT_DIR/$1"
121 if now_=$(cat "$GIT_DIR/$1") && test "$now_" = "$2"
123 [ "$verbose" ] && echo >&2 "* $1: same as $3"
125 echo >&2 "* $1: updating with $3"
128 echo >&2 "* $1: storing $3"
130 git-update-ref "$1" "$2"
134 # $1 is the ref being updated.
135 # $2 is the new value for the ref.
136 local=$(git-rev-parse --verify "$1^0" 2>/dev/null)
139 # Require fast-forward.
140 mb=$(git-merge-base "$local" "$2") &&
143 echo >&2 "* $1: same as $3"
146 echo >&2 "* $1: fast forward to $3"
147 git-update-ref "$1" "$2" "$local"
153 echo >&2 "* $1: does not fast forward to $3;"
154 case ",$force,$single_force," in
156 echo >&2 " forcing update."
157 git-update-ref "$1" "$2" "$local"
160 echo >&2 " not updating."
165 echo >&2 "* $1: storing $3"
166 git-update-ref "$1" "$2"
172 case "$update_head_ok" in
174 orig_head=$(git-rev-parse --verify HEAD 2>/dev/null)
178 # If --tags (and later --heads or --all) is specified, then we are
179 # not talking about defaults stored in Pull: line of remotes or
180 # branches file, and just fetch those and refspecs explicitly given.
181 # Otherwise we do what we always did.
183 reflist=$(get_remote_refs_for_fetch "$@")
186 taglist=$(git-ls-remote --tags "$remote" |
193 # remote URL plus explicit refspecs; we need to merge them.
194 reflist="$reflist$LF$taglist"
196 # No explicit refspecs; fetch tags only.
205 # These are relative path from $GIT_DIR, typically starting at refs/
207 if expr "$ref" : '\.' >/dev/null
210 ref=$(expr "$ref" : '\.\(.*\)')
214 if expr "$ref" : '\+' >/dev/null
217 ref=$(expr "$ref" : '\+\(.*\)')
221 remote_name=$(expr "$ref" : '\([^:]*\):')
222 local_name=$(expr "$ref" : '[^:]*:\(.*\)')
224 rref="$rref$LF$remote_name"
226 # There are transports that can fetch only one head at a time...
228 http://* | https://*)
229 if [ -n "$GIT_SSL_NO_VERIFY" ]; then
232 remote_name_quoted=$(perl -e '
234 $u =~ s{([^-a-zA-Z0-9/.])}{sprintf"%%%02x",ord($1)}eg;
237 head=$(curl -nsfL $curl_extra_args "$remote/$remote_name_quoted") &&
238 expr "$head" : "$_x40\$" >/dev/null ||
239 die "Failed to fetch $remote_name from $remote"
240 echo >&2 Fetching "$remote_name from $remote" using http
241 git-http-fetch -v -a "$head" "$remote/" || exit
244 TMP_HEAD="$GIT_DIR/TMP_HEAD"
245 rsync -L -q "$remote/$remote_name" "$TMP_HEAD" || exit 1
246 head=$(git-rev-parse --verify TMP_HEAD)
248 test "$rsync_slurped_objects" || {
249 rsync -av --ignore-existing --exclude info \
250 "$remote/objects/" "$GIT_OBJECT_DIRECTORY/" || exit
252 # Look at objects/info/alternates for rsync -- http will
253 # support it natively and git native ones will do it on the remote
254 # end. Not having that file is not a crime.
255 rsync -q "$remote/objects/info/alternates" \
256 "$GIT_DIR/TMP_ALT" 2>/dev/null ||
257 rm -f "$GIT_DIR/TMP_ALT"
258 if test -f "$GIT_DIR/TMP_ALT"
260 resolve_alternates "$remote" <"$GIT_DIR/TMP_ALT" |
263 case "$alt" in 'bad alternate: '*) die "$alt";; esac
264 echo >&2 "Getting alternate: $alt"
265 rsync -av --ignore-existing --exclude info \
266 "$alt" "$GIT_OBJECT_DIRECTORY/" || exit
268 rm -f "$GIT_DIR/TMP_ALT"
270 rsync_slurped_objects=t
274 # We will do git native transport with just one call later.
278 append_fetch_head "$head" "$remote" \
279 "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
284 http://* | https://* | rsync://* )
285 ;; # we are already done.
289 git-fetch-pack "$remote" $rref || echo failed "$remote"
291 while read sha1 remote_name
295 echo >&2 "Fetch failure: $remote"
323 local_name=$(expr "$found" : '[^:]*:\(.*\)')
324 append_fetch_head "$sha1" "$remote" \
325 "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
330 # If the original head was empty (i.e. no "master" yet), or
331 # if we were told not to worry, we do not have to check.
332 case ",$update_head_ok,$orig_head," in
336 curr_head=$(git-rev-parse --verify HEAD 2>/dev/null)
337 if test "$curr_head" != "$orig_head"
339 git-update-ref HEAD "$orig_head"
340 die "Cannot fetch into the current branch."